/*
* 画像貼り付けした基本図形(Sphere)の円運動
* use papervision3d
*/

package  {
	//必要なクラスのimport
	import flash.display.Sprite;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.render.BasicRenderEngine;

	import org.papervision3d.objects.primitives.Sphere;
	import flash.events.Event;
	import org.papervision3d.materials.BitmapFileMaterial;

	public class Sample09 extends Sprite { //Spriteクラス継承
		public var viewport:Viewport3D;
		public var scene:Scene3D;
		public var camera:Camera3D;
		public var renderer:BasicRenderEngine;

		public var sphere:Sphere;

		private var degrees_int:int = 0;//角度
		private var centerx_int:int = 0;//中心x座標(0がStage上中心)
		private var centerz_int:int = 0;//中心z座標
		private var diameter_int:int = 500;//半径
		private var speed_int:int = 5;//毎回の移動角度

		//コンストラクタ
		public function Sample09() {
			init();//初期化関数開始
		}

		//初期化関数
		public function init():void{
			viewport = new Viewport3D(550 , 400);
			addChild(viewport);//viewportを表示ツリーに追加

			renderer = new BasicRenderEngine();
			scene = new Scene3D();
			camera = new Camera3D();

			//BitmapFileMaterialを引数として渡す
			sphere = new Sphere(new BitmapFileMaterial("http://www.aoharu-b.com/cgi/sk/img/study_p3d/papervision3d03back.jpg"));
			scene.addChild(sphere);

			addEventListener(Event.ENTER_FRAME , onEnterFrame);//ENTER_FRAMEイベント定義
		}

		//ENTER_FRAME時関数
		public function onEnterFrame(event:Event):void {
			sphere.x = Math.sin(degrees_int * Math.PI/180) * diameter_int + centerx_int;
			sphere.z = Math.cos(degrees_int * Math.PI/180) * diameter_int + centerz_int;
			degrees_int += speed_int;
			degrees_int %= 360;//360以上になった場合に0～へ戻す
			renderer.renderScene(scene, camera, viewport);//描画
		}
	}
}
